$(function ($) {
    var showPersonDataModal = $("#showPersonDataModal");
    var resetPasswordModal = $("#resetPasswordModal");
    var renewPasswordModal = $("#renewPasswordModal");
    var passwordChangedModal = $("#passwordChangedModal");
    var sendToEmailModal = $("#sendToEmailModal");
    var sendToEmailField = $("#sendToEmailField");


    $(".showPersonDataBt").click(function () {
        var personRow = $(this).parent().parent().parent().parent();
        var personId = personRow.data("personId");
        $.get("{{ path(personType == "teacher" ? "teacher_show" : "student_show",{'providerId': provider is defined ? provider.id : '', 'id': '%personId'}) }}".replace("%25personId", personId), {}, function (data) {
            if (data === undefined || data === "") {
                alert("Non &egrave; stato possibile recuperare i dati dal server.");
                return;
            }

            showPersonDataModal.data("personId", personId);
            showPersonDataModal.data("personName", personRow.data("personName"));
            var modalContent = showPersonDataModal.children(".modal-dialog").children(".modal-content");
            modalContent.children(".modal-body").html(data);
            modalContent.children(".modal-footer").children("#modalEditPersonDataBt").attr("href", "{{ path(personType == "teacher" ? "teacher_edit" : "student_edit",{'groupId': group is defined ? group.id : '', 'id': '%personId'}) }}".replace("%25personId", personId));
            modalContent.children(".modal-footer").children("#modalPrintPersonDataBt").attr("href", "{{ path(personType == "teacher" ? "teacher_badge" : "student_badge",{'providerId': provider is defined ? provider.id : '', 'id': '%personId', '_format': 'pdf'})|raw }}".replace("%25personId", personId));
            showPersonDataModal.modal("show");
        }).fail(function (event, jqXHR) {
            alert('Errore durante l\'elaborazione della richiesta');
        });
    });

    $(".resetPersonPasswordBt").click(function () {
        var personRow = $(this).parent().parent().parent().parent();
        var personId = personRow.data("personId");
        var personName = personRow.data("personName");
        var personPassword = $(this).data("person-pass");
        var modalContent = resetPasswordModal.children(".modal-dialog").children(".modal-content");
        var modalBody = modalContent.children(".modal-body");
        var statusArea = modalContent.children(".modal-body").children('.status');

        statusArea.removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");
        modalBody.children('.personName').text(personName);
        modalBody.children('.personPassword').text(personPassword);
        modalContent.children('.modal-footer').children('a.btn').click(function () {
            var targetService = $(this).data('target-service') || 'all';
            $.post("{{ path(personType == "teacher" ? "teacher_reset_password_ajax" : "student_reset_password_ajax") }}", {
                'providerId': '{{ provider is defined ? provider.id : '' }}',
                'id': personId,
                'targetService': targetService
            }, function (data) {
                console.log(data);
                if (data.success !== true) {
                    statusArea.addClass("alert").addClass("alert-danger").html('Errore durante l\'elaborazione della richiesta:<br />' + data.error);
                    return;
                }

                resetPasswordModal.modal("hide");
                var modalContent = passwordChangedModal.children(".modal-dialog").children(".modal-content");
                modalContent.children(".modal-body").children('.personName').text(personName);
                modalContent.children(".modal-body").children('.personPassword').text(personPassword);
                modalContent.children(".modal-footer").children("#modalPrintPersonDataBt").attr("href", "{{ path(personType == "teacher" ? "teacher_badge" : "student_badge",{'providerId': provider is defined ? provider.id : '', 'id': '%personId'})|raw }}".replace("%25personId", personId));
                passwordChangedModal.modal('show');
            }, "json").fail(function (event, jqXHR) {
                statusArea.addClass("alert").addClass("alert-danger").text('Errore durante l\'elaborazione della richiesta');
            });
        });

        resetPasswordModal.modal("show");
    });

    $(".renewPersonPasswordBt").click(function () {
        var personRow = $(this).parent().parent().parent().parent();
        var personId = personRow.data("personId");
        var personName = personRow.data("personName");
        var modalContent = renewPasswordModal.children(".modal-dialog").children(".modal-content");
        var statusArea = modalContent.children(".modal-body").children('.status');

        statusArea.removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");
        modalContent.children(".modal-body").children('.personName').text(personName);
        modalContent.children('.modal-footer').children('a.btn').click(function () {
            var targetService = $(this).data('target-service') || 'all';
            $.post("{{ path(personType == "teacher" ? "teacher_renew_password_ajax" : "student_renew_password_ajax") }}", {
                'providerId': '{{ provider is defined ? provider.id : '' }}',
                'id': personId,
                'targetService': targetService
            }, function (data) {
                if (data.success !== true) {
                    statusArea.addClass("alert").addClass("alert-danger").html('Errore durante l\'elaborazione della richiesta:<br />' + data.error);
                    return;
                }

                renewPasswordModal.modal("hide");
                var modalContent = passwordChangedModal.children(".modal-dialog").children(".modal-content");
                modalContent.children(".modal-body").children('.personName').text(personName);
                modalContent.children(".modal-body").children('.personPassword').text(data.newPassword);
                modalContent.children(".modal-footer").children("#modalPrintPersonDataBt").attr("href", "{{ path(personType == "teacher" ? "teacher_badge" : "student_badge",{'providerId': provider is defined ? provider.id : '', 'id': '%personId'})|raw }}".replace("%25personId", personId));
                passwordChangedModal.modal('show');
            }, "json").fail(function (event, jqXHR) {
                statusArea.addClass("alert").addClass("alert-danger").text('Errore durante l\'elaborazione della richiesta');
            });
        });
        renewPasswordModal.modal("show");
    });

    $("#modalSendPersonDataBt").click(function () {
        if (showPersonDataModal.data("personId") === "" || showPersonDataModal.data("personName") === "") {
            return;
        }

        showPersonDataModal.modal("hide");
        var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
        modalContent.children(".modal-body").children('.personName').text(showPersonDataModal.data("personName"));
        modalContent.children(".modal-body").children('.status').removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");
        $("#sendToEmailField").val("");
        sendToEmailModal.modal("show");
    });

    $("#sendToEmailBt").click(function () {
        if (showPersonDataModal.data("personId") === "") {
            return;
        }

        var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
        var statusArea = modalContent.children(".modal-body").children('.status');
        statusArea.removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");

        if (sendToEmailField.val() === "") {
            statusArea.addClass("alert").addClass("alert-danger").text("E-Mail non valida");
            return;
        }

        $.get("{{ path(personType == "teacher" ? "teacher_send_credential_to_email" : "student_send_credential_to_email", {'id': '%personId'}) }}".replace("%25personId", showPersonDataModal.data("personId")), {'emailTo': sendToEmailField.val()}, function (data) {
            if (data.success !== true) {
                statusArea.addClass("alert").addClass("alert-danger").html('Errore durante l\'elaborazione della richiesta:<br />' + data.error);
                return;
            }

            statusArea.addClass("alert").addClass("alert-success").text('Email inviata correttamente');
            sendToEmailField.val("");
        }, "json").fail(function (event, jqXHR) {
            statusArea.addClass("alert").addClass("alert-danger").text('Errore durante l\'elaborazione della richiesta');
        });
    });


    $(document).ajaxError(function (event, jqXHR) {
        if (jqXHR.status === 403 && jqXHR.responseText === "Authentication timeout") {
            window.location.reload();
        }
    });

    $('.table-responsive').on('shown.bs.dropdown', function (e) {
        var $table = $(this),
            $menu = $(e.target).find('.dropdown-menu'),
            tableOffsetHeight = $table.offset().top + $table.height(),
            menuOffsetHeight = $menu.offset().top + $menu.outerHeight(true);

        if (menuOffsetHeight > tableOffsetHeight)
            $table.css("padding-bottom", menuOffsetHeight - tableOffsetHeight);
    }).on('hide.bs.dropdown', function () {
        $(this).css("padding-bottom", 0);
    });

});
